package namespace

import (
	"github.com/matryer/is"
	"testing"
)

func TestQuota(t *testing.T) {
	is := is.New(t)
	quota := FileSizeQuota{1000, 0}

	is.True(quota.Allows(1000))
	is.True(!quota.Allows(1001))
}

func TestQuotaManipulation(t *testing.T) {
	is := is.New(t)
	quota := FileSizeQuota{1000, 0}
	quota = quota.Add(500)
	is.Equal(quota.CurrentUsage, int64(500))
	quota = quota.Remove(1000)
	is.Equal(quota.CurrentUsage, int64(-500))
}
